freeslot("SPR_BUTN", "SPR_GBNA", "SPR_ICE_")
freeslot("sfx_forcsg", "sfx_tcuse", "sfx_tcwarn", "sfx_tchit", "sfx_tcpass", "sfx_tcdie", "sfx_hwooih", "sfx_icehit", "sfx_freeze")
freeslot("S_MASH")
freeslot("MT_MASH")

states[S_MASH] = {SPR_BUTN, FF_FULLBRIGHT|FF_ANIMATE|A, 1, nil, 0, 0, S_NULL}

mobjinfo[MT_MASH] = {
    spawnstate = S_MASH,
    radius = 1*FRACUNIT,
    height = 1*FRACUNIT,
    flags = MF_SCENERY|MF_NOGRAVITY|MF_FLOAT|MF_NOCLIP|MF_NOCLIPHEIGHT
}

-- Global functions
local travelangle, newx, newy, flame
rawset(_G, "P_ElementalFire", function(p)
	travelangle = R_PointToAngle2(0, 0, p.rmomx, p.rmomy)

	for i = 0, 2 do
		newx = p.mo.x + P_ReturnThrustX(p.mo, (travelangle + ((i&1) and -1 or 1)*ANGLE_135), FixedMul(24*FRACUNIT, p.mo.scale))
		newy = p.mo.y + P_ReturnThrustY(p.mo, (travelangle + ((i&1) and -1 or 1)*ANGLE_135), FixedMul(24*FRACUNIT, p.mo.scale))

		flame = P_SpawnMobj(newx, newy, p.mo.z, MT_SPINFIRE)
		flame.source = p.mo
		flame.flags = $|MF_PAIN
		flame.target = p.mo
		flame.angle = travelangle
		flame.fuse = TICRATE*6
		flame.destscale = p.mo.scale
		P_SetScale(flame, p.mo.scale)
		flame.eflags = (flame.eflags & ~MFE_VERTICALFLIP)|(p.mo.eflags & MFE_VERTICALFLIP)

		flame.momx = 8 // this is a hack which is used to ensure it still behaves as a missile and can damage others
--		P_XYMovement(flame)

		if (p.mo.eflags & MFE_VERTICALFLIP) then
			if (flame.z + flame.height < flame.ceilingz) then P_RemoveMobj(flame) end
		elseif (flame.z > flame.floorz) then
			P_RemoveMobj(flame)
		end
	end
end)