-- PLAYER THINK
local thinkers = {}
rawset(_G, "K_AddPThink", function(func)
	thinkers[#thinkers+1] = func
end)

local curthink
addHook("ThinkFrame", function()
	if not #thinkers then return end

	for p in players.iterate do
		if not p.mo or not p.mo.valid then continue end -- validity checks unneeded.

		for i = 1, #thinkers do
			thinkers[i](p)
		end
	end
end)

-- PLAYER BONK
local bonks = {}
rawset(_G, "K_AddPBonk", function(func)
	bonks[#bonks+1] = func
end)

local p, p2
local function bonkThinkers(mo, mo2)
	if not #bonks then return end

	if not mo or not mo.valid then return end
	if not mo2 or not mo2.valid then return end
	if not mo2.player then return end
	p = mo.player
	p2 = mo2.player

	if (p.kartstuff[k_justbumped] or p2.kartstuff[k_justbumped]) then return end
	if (p.kartstuff[k_squishedtimer] or p.kartstuff[k_spinouttimer]) then return end
	if (p.powers[pw_flashing] and not p.kartstuff[k_hyudorotimer]) then return end
	if (p2.kartstuff[k_invincibilitytimer] or (p2.kartstuff[k_growshrinktimer] > 0) or p2.kartstuff[k_hyudorotimer]) then return end

	if (abs(mo.z - mo2.z) <= P_GetPlayerHeight(p2)) then
		for i = 1, #bonks do
			bonks[i](mo, mo2)
		end
	end
end
	
addHook("MobjCollide", bonkThinkers, MT_PLAYER)
addHook("MobjMoveCollide", bonkThinkers, MT_PLAYER)